*// ============================================================================================ //
#include "define.h" 
*// ============================================================================================ //
define class es_grid as grid

   *// ------------------------------------------------------------ //
   RecordSourceType = 1
   deletemark = .F.
   AllowHeaderSizing = .F.
   AllowRowSizing = .F.
   splitbar = .T.
   height = 300
   keyclass = "grid"
   *// ------------------------------------------------------------ // 
   MinWidth  = 20                    &&//  
   MinHeight = 27                    &&// --- // ----
   MaxWidth  = -1
   MaxHeight = -1
   SourcePoint = 0                   &&//   (   )
   attachment    = ATTACH_TOP        &&//    
   justification = JUSTIFY_LEFT      &&//  
   NextDirection = DIRECT_RIGHT      &&//     
   lNewRow = .T.                     &&//    
   lHorizStretch = .T.               &&//  
   lVertStretch  = .T.               &&//  
   nTopSpace = 0                     &&//   
   nLeftSpace = 0                    &&//   
   *// ------------------------------------------------------------ //
   nColumnSorted = 0                 &&//    
   lExt      = .F.                   &&//   
   lRegLoad  = .F.                   &&//     
   nView     = .F.                   &&//  
   *// ------------------------------------------------------------ //
   lAdd = .T.                        &&//      
   lDel = .T.                        &&//     
   lConfirmAdd = .F.                 &&//   
   lConfirmDel = .T.                 &&//   
   *// ------------------------------------------------------------ //
   lFirstJump = .F.                  &&//       
   lLastJump  = .F.                  &&//       
   nJumpMode = 0
   nPostOperation = 0
   *// ------------------------------------------------------------ //
   source = .F.                      &&//   
   *// ------------------------------------------------------------ //
   cColClass     = "es_column"
   cControlClass = "es_text_reg"
   cHeadClass    = "es_head"
   *// ------------------------------------------------------------ //


   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   function init
   local i, oTable
      &&//   
      if this.recordsourcetype == 1 and vartype( this.recordsource ) == 'C' and object( thisform.source )
         this.source = thisform.source.cursfind( this.recordsource )
      endif
      &&// 
      if this.parent.keyclass == "extgrid"
         this.lExt = .T.
         this.lRegLoad = .F.
         this.nView = this.parent.nView
      endif
      &&//      
      if !numeric( this.nView )
         oTable = createobject( "es_reg_table" )
         if object( oTable ) and oTable.find( "name", lower(this.recordsource) )
            this.nView = table.id
            oTable = .F.
            if this.lExt
               this.parent.nView = this.nView
            endif
         endif
      endif
      &&//     
      if object(this.source) and this.lRegLoad           
         this.source.activate()
         this.RegLoad()
      endif
      &&//   
      if object( this.source )
         this.source.lConfirmAdd = this.lConfirmAdd
         this.source.lConfirmDel = this.lConfirmDel
      endif
   endfun
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   function destroy
      if this.lRegLoad
         this.StoreOrder()
      endif
   endfun
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   function scrolled
   parameters nDirection
      if this.lExt and nDirection >= 4 and nDirection <= 7
         this.parent.treat( GRID_SCROLLED, nDirection )
      endif
   endfun
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
*   function BeforeRowColChange
*   parameters nColIndex
*      if this.lExt
*         thisform.lockscreen = .T.
*      endif
*   endfun
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   function AfterRowColChange
   parameters nColIndex
      if this.lExt and ;
         (( this.panel == 0 and this.parent.nLLeftColumn != this.leftcolumn ) or;
          ( this.panel == 1 and this.parent.nRLeftColumn != this.leftcolumn ))
         this.parent.treat( AFTER_ROW_COL_CHANGE, nColIndex )
      endif
*      if this.lExt
*         thisform.lockscreen = .f.
*         thisform.refresh()
*      endif
   endfun
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   



   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   *//      e
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   function RegLoad
   parameters viewstruct
   local i, cColClass, lcolumn

      SetErrorEmpty()
      thisform.lockscreen = .T.
      &&//   view
      if !object( viewstruct )
         viewstruct = createobject( "es_view_struct" )
         if !object( viewstruct ) or !viewstruct.regload( this.nView, thisform.source ) or viewstruct.count <= 0
            return .F.
         endif
      endif
      
      &&//  ,  
      for i = this.columncount to 1 step -1
          this.deletecolumn( i )
      endfor
      &&//        
      for i = 1 to viewstruct.count
        cColClass = viewstruct.list[i].cClassCol
        cColClass = iif( len(cColClass) == 0, this.cColClass, cColClass )
        this.addobject( "column" + itoc(i), cColClass, i, viewstruct )
        SetErrorEmpty()
        lColumn = .F.
        lColumn = object( this.columns[this.columncount] )
        SetErrorComm()
        if lColumn
           this.columns[this.columncount].visible = .T.
        endif
      endfor
      *// -------------------------
      this.nColumnSorted = viewstruct.nSortCol
      if this.nColumnSorted > 0
         this.SetOrder(this.nColumnSorted)
      endif
      thisform.lockscreen = .F.
      *// -------------------------
      if this.lFirstJump and this.columncount > 0
         this.columns[1].text.nJumpMode = JUMP_FROM_GRID
      endif
      if this.lLastJump and this.columncount > 0
         this.columns[this.columncount].text.nJumpMode = JUMP_FROM_GRID
      endif
      *// -------------------------
      SetErrorComm()
   endfun
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //


    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    *//   o    
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    function SetOrder
    parameters nOrder
       if empty( nOrder )
          nOrder = this.nColumnSorted
       endif
       if nOrder <= 0 or !this.source.ordset( this.columns[nOrder].order )&&// 
          return .f.
       endif
       if this.nColumnSorted > 0
          this.columns[this.nColumnSorted].header.UndoSortColor()
       endif
       this.columns[nOrder].header.SetSortColor()
       this.nColumnSorted = nOrder
       thisform.refresh()
       this.parent.treat( GRID_ORDER_CHANGE, this.nColumnSorted )
       return .t.
    endfun
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    *//      
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    function StoreOrder
    local oView, oViewCol, oViewArm, oViewUsr, nIndex, nColumn
       if this.nColumnSorted > 0
          oView = createobject( "es_de_col" )
          if !object( oView )
             return .F.
          endif
          &&//     
          oViewCol = oView.view_col
          oViewArm = oView.view_arm
          oViewUsr = oView.view_usr
          &&//       .  
          oView.SetUserFilter( this.nView )
          &&//     
          nIndex = this.columns[this.nColumnSorted].regindex
          if !oViewCol.find( "index", nIndex )
             return .F.
          endif
          nColumn = view_col.col_id
          *// ------------------------------------------------------------ //
          &&//   
          if oViewUsr.find( 'sorted', .T. )
             oViewUsr.replace( 'sorted', .F. )
          endif
          do case
             case oViewUsr.find( 'col_id', nColumn )
                  &&//   
                  oViewUsr.replace( 'sorted', .T. )
                  if !oViewArm.find( "sorted", .T. ) and oViewArm.find( 'col_id', nColumn )
                     oViewArm.replace( 'sorted', .T. )
                  endif
                  if !oViewCol.find( "sorted", .T. ) and oViewCol.find( 'col_id', nColumn )
                     oViewCol.replace( 'sorted', .T. )
                  endif
             case oViewArm.find( 'col_id', nColumn )
                  &&//   
                  if oViewArm.find( 'sorted', .T. )
                     oViewArm.replace( 'sorted', .F. )
                  endif
                  &&//   
                  oViewArm.find( 'col_id', nColumn )
                  oViewArm.replace( 'sorted', .T. )
                  if !oViewCol.find( "sorted", .T. ) and oViewCol.find( 'col_id', nColumn )
                     oViewCol.replace( 'sorted', .T. )
                  endif
             otherwise
                  &&//   
                  if oViewArm.find( 'sorted', .T. )
                     oViewArm.replace( 'sorted', .F. )
                  endif
                  if oViewCol.find( 'sorted', .T. )
                     oViewCol.replace( 'sorted', .F. )
                  endif
                  &&//   
                  if oViewCol.find( 'col_id', nColumn )
                     oViewCol.replace( 'sorted', .T. )
                  endif
          endcase
       endif
    endfun
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    *//    
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    function ExtSeek
       if object( this.source )
          return this.source.ExtSeekWin()
       endif
       return .F.
    endfun
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //


    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    *//        
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    function AddRecord
       if !thisform.readonly and this.lAdd and object( this.source ) and this.BeforeAdd() and this.source.new()
          this.AfterAdd()
          this.refresh()
       endif
    endfun
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    function CopyRecord
    local xKey, lConfirmDel, lConfirmAdd
       if !thisform.readonly and this.lAdd and object( this.source )
          this.source.prepare()
          lConfirmDel = this.source.lConfirmDel
          lConfirmAdd = this.source.lConfirmAdd
          this.source.lConfirmDel = .F.
          this.source.lConfirmAdd = .F.
          copy next 1 to array abuff
          if string( this.source.cLeadTag )
             this.source.new()
             xKey = this.source.getval( this.source.cLeadTag )
             this.source.delete()
          endif
          abuff[1,this.source.fldindex( this.source.cLeadTag )] = xKey
          append from array abuff
          this.source.external.storerecord()
          this.source.lConfirmDel = lConfirmDel
          this.source.lConfirmAdd = lConfirmAdd
          this.source.restore()
          this.refresh()
       endif
    endfun
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    *//    ,   AddRecord
    *//     .F. ,     
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    function BeforeAdd
       return .T.
    endfun
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    *//   ,    
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    function AfterAdd
    endfun
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //


    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    *//       
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    function DelRecord
       if !thisform.readonly and this.lDel and object( this.source ) and this.BeforeDel() and this.source.delete()
          this.AfterDel()
          this.refresh()
       endif
    endfun
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    *//    ,   DelRecord
    *//     .F. ,     
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    function BeforeDel
       return .T.
    endfun
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    *//   ,    
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    function AfterDel
    endfun
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    function keypress
    parameters nKeyCode, nShiftAltCtrl
       do case
          case nKeyCode == 30  &&// Ctrl + PgDn
               this.source.gobottom()
               this.refresh
          case nKeyCode == 31  &&// Ctrl + PgUp
               this.source.gotop()
               this.refresh
       endcase
    endfun
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    
    
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   *//   . 
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   function treat
   parameters nEvent, xParam
   endfun
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //


enddefine
*// ============================================================================================ //




*// ============================================================================================ //
*//     view - 
*// ============================================================================================ //
define class es_grid_view as es_grid
   keyclass = "maingrid"
   *// -------------------------
   function init
      SetErrorEmpty()
      this.recordsource = thisform.maincurs.alias
      this.lRegLoad = thisform.lRegLoad
      this.nView = thisform.nView
      SetErrorComm()
      if !dodefault()
         return .F.
      endif
      if !numeric( thisform.nView )
         thisform.nView = this.nView
      endif
   endfun
enddefine
*// ============================================================================================ //