#include "define.h"
*// ============================================================================================ //
*//    -   
*// ============================================================================================ //
define class es_ext_grid as es_container
 
    
    *// ------------------------------------------------------------ //
    height = 300
    keyclass = "extgrid"
    *// -------------------------
    lHorizStretch = .T.
    lVertStretch  = .T.
    *// ------------------------------------------------------------ //
    nView = .F.                    &&//  view  
    lRegLoad = .T.
    lSplit   = .F.                 &&//  
    *// ------------------------------------------------------------ //
    cGridClass = "es_grid"         &&//  
    cHeadersClass = "es_cont_headers" &&//   
    cHeadClass = "es_ext_head"     &&//   
    l3D = .T.                      &&//   
    nMaxLevel  = 5                 &&//   
    *// -------------------------
    lIndex = .t.                   &&//      
    *// -------------------------
    nLLeftColumn  = 0              &&//    ;)
    nRLeftColumn = 0               &&//        ;)
    nPartition   = -1              &&//    
    nCorner      = 0               &&//   
    *// ------------------------------------------------------------ //

    
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    function init
    parameters l3D, lIndex
      dodefault()
      SetErrorEmpty()
      this.l3D    = iif( vartype( l3D )    == 'N', anytol( l3D ),    this.l3D )
      this.lIndex = iif( vartype( lIndex ) == 'N', anytol( lIndex ), this.lIndex )
      *// -------------------------
      if !numeric( this.nView ) and numeric( thisform.nView )
         this.nView = thisform.nView
      endif
      this.addobject( "grid", this.cGridClass )
      this.grid.headerheight = 0
      *// -------------------------
      this.lSplit = this.grid.splitbar
      this.addobject( "rbanner", this.cHeadersClass )
      if this.lSplit
         this.addobject( "lbanner", this.cHeadersClass )
      endif
      this.addobject( "CornerBox", "es_container" )
      this.CornerBox.left = 1
      this.CornerBox.top = 1
      this.CornerBox.specialeffect = 0
      this.addobject( "PartitionBox", "es_container" )
      this.PartitionBox.left = 0
      this.PartitionBox.top = 1
      this.PartitionBox.specialeffect = 0
      *// -------------------------
      if this.lRegLoad
         this.regload()
      endif
      this.CornerBox.visible = .T.
      this.grid.visible = .T.
      this.rbanner.top = 1
      this.rbanner.visible = .T.
      if this.lSplit
         this.lbanner.top = 1
         this.lbanner.visible = .T.
      endif
      SetErrorComm()
    endfun
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    function destroy
      if this.lRegLoad
         this.grid.storeorder()
      endif
    endfun
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    function resize
       this.RefreshCont()
    endfun
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    function RefreshCont
       this.nCorner = iif( this.grid.recordmark, 11, 0 )
       this.grid.top = this.rbanner.height + 1
       this.grid.height = this.height - this.rbanner.height - 1
       this.grid.width  = this.width
       *// -------------------------
       if this.grid.panel == 0
          if this.lSplit
             this.lbanner.left = this.nCorner - this.rbanner.topheads[this.grid.leftcolumn].left
             this.nLLeftColumn = this.grid.leftcolumn
          endif
          this.rbanner.left = ( this.nCorner + this.grid.partition ) - this.rbanner.topheads[max(this.nRLeftColumn,1)].left
       else
          this.rbanner.left = ( this.nCorner + this.grid.partition ) - this.rbanner.topheads[this.grid.leftcolumn].left
          this.nRLeftColumn = this.grid.leftcolumn
          if this.lSplit
             this.lbanner.left = this.nCorner - this.rbanner.topheads[max(this.nLLeftColumn,1)].left
          endif
       endif
       *// -------------------------
       this.CornerBox.width  = this.nCorner - 1
       this.CornerBox.height = this.rbanner.height
       this.PartitionBox.width  = this.nCorner
       this.PartitionBox.height = this.rbanner.height
       *// -------------------------
       if this.lSplit
         if this.grid.partition == 0
            this.lbanner.visible = .F.
         else
            this.lbanner.visible = .T.
            this.lbanner.width = this.grid.partition - this.lbanner.left - 1
         endif
       endif
       this.rbanner.width = this.width - this.rbanner.left - 1
    endfun
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    *//      
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    function RegLoad
    local ViewStruct
       ViewStruct = createobject( "es_view_struct" )
       if !object( ViewStruct )
          return .F.
       endif
       ViewStruct.ExtRegLoad( this.nView, thisform.source )
       this.rbanner.load( ViewStruct, this.lIndex, this.l3D )
       if this.lSplit
          this.lbanner.load( ViewStruct, this.lIndex, this.l3D )
       endif
       this.grid.regload( ViewStruct )
       this.RefreshCont()
    endfun
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   
    
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    *//   
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    function treat
    parameters nEvent, xParam
      do case
         case nEvent == CONT_HEADER_CLICK
              return this.grid.SetOrder( xParam )
         case nEvent == GRID_ORDER_CHANGE
              this.rbanner.HighLight( xParam )
              if this.lSplit
                 this.lbanner.HighLight( xParam )
              endif
         case nEvent == GRID_SCROLLED
*              messagebox( "Scrolled!",0,"" )
              this.RefreshCont()
         case nEvent == AFTER_ROW_COL_CHANGE
*              messagebox( "AfterRC..",0,"" )
              this.RefreshCont()
         case nEvent == PARENT_WINDOW_PAINT
              if this.nPartition != this.grid.partition
                 if this.nPartition != -1
                    this.RefreshCont()
                    if this.grid.partition == 0
                       this.PartitionBox.visible = .F.
                    else
                       this.PartitionBox.left = this.grid.partition
                       this.PartitionBox.visible = .T.
                    endif
                 endif
                 this.nPartition = this.grid.partition
              endif
         otherwise 
              return .f.
      endcase
      return .t.
    endfun
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //

  

enddefine
*// ============================================================================================ //
*// ============================================================================================ //
define class es_ext_grid_view as es_ext_grid
    cGridClass = "es_grid_view"
enddefine
*// ============================================================================================ //