*// ============================================================================================ //
*//    
*// ============================================================================================ //
define class es_view_struct as es_array_one
   *// ------------------------------------------------------------ //
   nView = .F.          &&//   
   nMaxStorey = 0       &&//   ''   
   nMaxLevel  = 0       &&//     ,   ''    
   cClassCol = "es_view_column"
   lExtLoad = .T.       &&//   
   *// -------------------------
   nSortCol = 0 
   nSortArm = 0
   nSortUsr = 0
   *// ------------------------------------------------------------ //


   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   function RegLoad
   parameters nView, oSource
      this.lExtLoad = .F.
      return this.load( nView, oSource )
   endfun
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   function ExtRegLoad
   parameters nView, oSource
      this.lExtLoad = .T.
      return this.load( nView, oSource )
   endfun
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   *//    
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   function load
   parameters nView, oSource
   local oView, oViewCol, oViewArm, oViewUsr,;
         nSortCol, nSortArm, nSortUsr,;
         nStorey, nPrvIndex
      oView = createobject( "es_de_col" )
      if !object( oView )
         return .F.
      endif
      *// -------------------------
      if numeric( nView )
         this.nView = nView
      endif
      *// -------------------------
      &&//     
      oViewCol = oView.view_col
      oViewArm = oView.view_arm
      oViewUsr = oView.view_usr
      &&//       .  
      oView.SetUserFilter( this.nView )
      &&//    
      this.nMaxStorey = 0
      nPrvIndex = 0
      this.clear()
      oViewCol.gotop()
      oViewCol.activate()
      &&//        
      scan while !eof()
        if !view_col.enabled or (!eof("view_arm") and !view_arm.enabled) or (!eof("view_usr") and !view_usr.enabled) or ;
           nPrvIndex == view_col.index
           loop
        endif
        nPrvIndex = view_col.index
        this.increase()                              &&//    
        if !this.list[this.curr].loadvar( oSource )  &&//     
           this.decrease()
           loop
        endif
        this.nSortCol = iif( view_col.sorted, this.curr, this.nSortCol )
        this.nSortArm = iif( view_arm.sorted, this.curr, this.nSortArm )
        this.nSortUsr = iif( view_usr.sorted, this.curr, this.nSortUsr )
        &&//   
        if this.lExtLoad
           this.list[this.curr].loadhead( rtrim(view_col.ext_header), this )
           nStorey = this.list[this.curr].StoreyCount()
           if nStorey > this.nMaxStorey
              this.nMaxStorey = nStorey
           endif
        endif
      endscan
      *// -------------------------
      do case
         case this.nSortUsr > 0
              this.nSortCol = this.nSortUsr
         case this.nSortArm > 0
              this.nSortCol = this.nSortArm
      endcase
      *// -------------------------
      this.arrange()
      *// -------------------------
      return .T.
   endfun
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   *//     
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   function arrange
   local nCol, nHead, nStoreyRest, oHead, nLevel
      for nCol = 1 to this.count
          nStoreyRest = this.nMaxStorey
          for nHead = 1 to this.list[nCol].count
              oHead = this.list[nCol].list[nHead]
              do case
                 case oHead.column != nCol
                      oHead.nWidthPix = oHead.nWidthPix + this.list[nCol].nWidthPix + 3
                      oHead.nWidthChr = oHead.nWidthChr + this.list[nCol].nWidthChr + 3
                 case oHead.nWidthCol > 1
                      oHead.nStoreyVirtual = round( (oHead.count / (oHead.StoreyGround(this,nHead) + oHead.count)) * nStoreyRest , 0 )
                      oHead.nWidthPix = this.list[nCol].nWidthPix + 2
                      oHead.nWidthChr = this.list[nCol].nWidthChr + 2
                 otherwise
                      oHead.nStoreyVirtual = nStoreyRest
                      oHead.nWidthPix = this.list[nCol].nWidthPix + 2
                      oHead.nWidthChr = this.list[nCol].nWidthChr + 2
              endcase
              nStoreyRest = nStoreyRest - oHead.nStoreyVirtual
          endfor
          nLevel = this.list[nCol].LevelCount()
          if nLevel > this.nMaxLevel
             this.nMaxLevel = nLevel
          endif
      endfor
   endfun
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   *//   
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   function add
   parameters xValue
     if empty( xValue )
        xValue = createobject( this.cClassCol )
        if object( xValue )
           xValue.index = this.count + 1
        endif
     endif
     return (object( xValue ) and dodefault(xValue))
   endfun
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   


enddefine
*// ============================================================================================ //
*//   
*// ============================================================================================ //
define class es_view_column as es_array_one
  *// ------------------------------------------------------------ //
  index = 0                        &&//     
  cHeadClass   = 'es_view_header'  &&//    
  *// -------------------------
  nIndex      = 0       &&//  
  lReadonly   = .F.     &&//   
  cField      = ''      &&//  
  cAlias      = ''      &&// ,   -  
  cGround     = ''      &&//    
  cClassCol   = ''      &&//  
  cClassCtrl  = ''      &&//     
  cClassHead  = ''      &&//   ()
  cClassEHead = ''      &&//   ()
  cOrder      = ''      &&//    
  nWidthPix   = 0       &&//    
  nWidthChr   = 0       &&//    
  lSeek       = .F.     &&//   
  nTouch      = .F.     &&//  Touch
  cHeader     = ''      &&//   ()
  nHorizJustify = 0
  lBoldTop    = .F.     
  lBoldBott   = .F.
  lBoldIndex  = .F.
  lBoldOther  = .F.
  lNull       = .f.
  *// ------------------------------------------------------------ //
  
  
  *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
  *//         . . 
  *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
  function add
  parameters xValue
     if boolean( xValue ) and !xValue
        xValue = createobject( this.cHeadClass  )
        xValue.column = this.index
     endif
     return = (object( xValue ) and dodefault(xValue))
  endfun
  *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
  *//       ( )
  *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
  function StoreyCount
  local i, nStorey
    nStorey = 0
    for i = 1 to this.count
        nStorey = nStorey + this.list[i].count
    endfor
    return nStorey
  endfun
  *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
  function LevelCount
  local i, nLevel
    nLevel = 1
    for i = 1 to this.count
        nLevel = nLevel + this.list[i].nStoreyVirtual + 1
    endfor
    return nLevel
  endfun
  *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
  *//        .
  *//          
  *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
  function HorizEdg
  parameters nStorey
  local nHead, nLevel, nLine
     if nStorey == 1
        return .T.
     endif
     *// -------------------------
     nLevel = 1
     for nHead = 1 to this.count - 1
         nLevel = nLevel + this.list[nHead].nStoreyVirtual + 1
         if nLevel == nStorey
            return .T.
         endif
     endfor
     return .F.
  endfun
  *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
  
  
  *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
  *//      
  *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
  function LoadVar
  parameters oSource
  local oMain, oCurs, cAlias
     this.nIndex      = view_col.index
     this.lReadonly   = ( view_col.readonly or view_arm.readonly or view_usr.readonly )
     this.cField      = alltrim( view_col.field )
     this.cAlias      = alltrim( view_col.alias )
     this.cGround     = rtrim( view_col.ground )
     this.cClassCol   = alltrim( view_col.col_class )
     this.cClassCtrl  = alltrim( view_col.ctrl_class )
     this.cClassHead  = alltrim( view_col.hed_class )
     this.cClassEHead = alltrim( view_col.ehed_class )
     this.cOrder      = alltrim( view_col.order )
     *// -------------------------
     oMain = iif( object(oSource), oSource.getmain(), .F. )
     cAlias = iif( object( oMain ), oMain.alias, .F. )
     oCurs = iif( object(oSource),;
                  oSource.cursfind( iif( len( this.cAlias ) == 0 and string( cAlias ), cAlias, this.cAlias )), .F. )
     if (object( oSource ) and !object( oCurs )) or (object( oCurs ) and !anytol(oCurs.fldfind( this.cField )))
        return .F.
     endif
     *// -------------------------
     this.nWidthPix   = iif( view_col.width     <= 0 and object( oCurs ), oCurs.fldlen( this.cField ) * 12, view_col.width )
     this.nWidthChr   = iif( view_col.width_chr <= 0 and object( oCurs ), oCurs.fldlen( this.cField ), view_col.width_chr )
     this.lSeek       = view_col.seek
     this.nTouch      = view_col.touch
     this.cHeader     = rtrim( view_col.header )
     *// -------------------------
     this.nHorizJustify = iif( object(oCurs) and oCurs.fldtype( this.cField ) == 'C', 0, 1 )
     *// -------------------------
     this.lBoldTop    = anytol( getatom( view_col.head_bold, 3 ) )
     this.lBoldBott   = anytol( getatom( view_col.head_bold, 2 ) )
     this.lBoldIndex  = anytol( getatom( view_col.head_bold, 1 ) )
     this.lBoldOther  = anytol( getatom( view_col.head_bold, 0 ) )
     *// -------------------------
     this.lNull = view_col.null
     *// -------------------------
     return .T.
  endfun
  *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
  *//    
  *//  "aaaaaaaa\;2;bbbbbbb\,cccccc\,ddddddd"
  *//  \;n;  -   
  *//  \,    -    
  *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
  function LoadHead
  parameters cHeadString, oParent
  local i, cHead, nAt, nWidthCol, nMaxWidth
    
    nMaxWidth = .F. &&//    (   >= )
    do while len( cHeadString ) > 0
       nAt = at( '\;', cHeadString )
       &&//          ( )
       if nAt > 0
          cHead = left( cHeadString, nAt - 1 )
          cHeadString = right( cHeadString, len( cHeadString ) - nAt - 1 )
          &&//   
          nAt = at( ';', cHeadString )
          nWidthCol = iif( nAt > 0, cton( left( cHeadString, nAt - 1 ) ), 0 )
          cHeadString = right( cHeadString, len( cHeadString ) - nAt )
          if nWidthCol <= 0 or (numeric(nMaxWidth) and nWidthCol >= nMaxWidth)
             loop
          endif
          nMaxWidth = nWidthCol
       else
          if numeric(nMaxWidth) and nMaxWidth == 1
             cHeadString = ''
             loop
          endif
          cHead = cHeadString
          cHeadString = ''
          nWidthCol = 1
       endif
       &&//    
       this.add()
       &&//     
       this.list[this.count].load( cHead )
       this.list[this.count].nWidthCol = nWidthCol
       *// -------------------------
       *//         ''  (>1)
       if nWidthCol > 1 and object( oParent )
          for i = 1 to nWidthCol - 1
              if oParent.count < this.index + i
                 oParent.add()
              endif
              &&//      
              oParent.list[this.index + i].add( this.list[this.count] )
          endfor
       endif
       
    enddo
  endfun
  *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
  
      
      
enddefine
*// ============================================================================================ //
*//   
*// ============================================================================================ //
define class es_view_header as es_array_one
  column    = 0  &&//  
  nWidthCol = 0  &&//    
  nWidthPix = 0
  nWidthChr = 0
  nStoreyVirtual = 0 &&//      
  *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
  *//      
  *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
  function load
  parameters cHead
  local cStorey, nAt
    if !string( cHead )
       return .F.
    endif
    *// -------------------------
    this.clear()
    do while len( cHead ) > 0
       nAt = at( "\,", cHead )
       &&//      
       if nAt > 0
          cStorey = left( cHead, nAt - 1 )
          cHead = right( cHead, len( cHead ) - nAt - 1 )
       else
          cStorey = cHead
          cHead = ''
       endif
       this.add( cStorey )
    enddo
  endfun
  *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
  *//         (   )
  *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
  function StoreyGround
  parameters oParent, nIndex
  local nCol, nHead, nStorey, nMaxStorey
     if !object( oParent )
        return 0
     endif
     *// -------------------------
     nMaxStorey = 0
     for nCol = this.column to this.column + this.nWidthCol - 1
         nStorey = 0
         for nHead = nIndex + 1 to oParent.list[nCol].count
             nStorey = nStorey + oParent.list[nCol].list[nHead].count
         endfor
         if nStorey > nMaxStorey
            nMaxStorey = nStorey
         endif
     endfor
     return nMaxStorey
  endfun
  *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
enddefine
*// ============================================================================================ //